#include "../CommonSrc/Skin.h"
#include <wx/wfstream.h>
#include <wx/zstream.h>

Skin::Skin()
{
    m_bIsOk=false;
    m_iVersion=0;
}

Skin::~Skin()
{
    //dtor
}

bool Skin::IsOk()
{
    return m_bIsOk;
}

bool Skin::Read(wxString sFName)
{
    if (!wxFileExists(sFName)) return false;
    wxFileInputStream f_in(sFName);
    wxZlibInputStream z_in(f_in);
    int iX,iY,iW,iH,iVer,iLen,i;
    // Lecture du numro de version
    z_in.Read(&iVer,sizeof(int));
    m_iVersion=iVer;
    // Lecture de la taille de la Skin
    z_in.Read(&iW,sizeof(int));
    z_in.Read(&iH,sizeof(int));
    m_bmpsize=wxSize(iW,iH);
    // Lecture et cration de l'image de masque
    iLen=iW*iH*3;
    unsigned char *szBuff=(unsigned char*)malloc(iLen);
    z_in.Read(szBuff,iLen);
    m_imgMask.Create(iW,iH,szBuff,true);
    m_imgMask.SetData(szBuff);
    //m_imgMask.SaveFile("(imgMask.bmp");
    // Lecture et cration de l'image normale
    szBuff=(unsigned char*)malloc(iLen);
    z_in.Read(szBuff,iLen);
    m_imgUp.Create(iW,iH,false);
    m_imgUp.SetData(szBuff);
    // Lecture et cration de l'image "Boutons presss"
    szBuff=(unsigned char*)malloc(iLen);
    z_in.Read(szBuff,iLen);
    m_imgDown.Create(iW,iH,false);
    m_imgDown.SetData(szBuff);
    // Lecture et cration ventuelles de l'image "Hover"
    if (m_iVersion>0)
    {
        szBuff=(unsigned char*)malloc(iLen);
        z_in.Read(szBuff,iLen);
        m_imgHover.Create(iW,iH,false);
        m_imgHover.SetData(szBuff);
    }
    // Lecture des tailles et positions des boutons dans l'ordre suivant :
    // "CloseButton","MinButton","OptionsButton","UpdateButton","AboutButton"
    for (i=0;i<5;i++)
    {
        z_in.Read(&iX,sizeof(int));
        z_in.Read(&iY,sizeof(int));
        z_in.Read(&iW,sizeof(int));
        z_in.Read(&iH,sizeof(int));
        m_btnrect[i]=wxRect(iX,iY,iW,iH);
    }
    // Lecture de la position de la HtmlWindow
    z_in.Read(&iX,sizeof(int));
    z_in.Read(&iY,sizeof(int));
    m_brwsrpos=wxPoint(iX,iY);
    m_bIsOk=true;
    return true;
}

wxImage Skin::GetButtonImage(int iBtnIndex,int ButtonState)
{
    if ((!m_bIsOk)||(iBtnIndex>4)) return wxImage(10,10,true);
    wxImage* img;
    switch(ButtonState)
    {
        case BTN_STATE_NORMAL:
            img=&m_imgUp;
            break;
        case BTN_STATE_PRESSED:
            img=&m_imgDown;
            break;
        case BTN_STATE_HOVER:
            if (m_iVersion==0)
                img=&m_imgUp;
            else
                img=&m_imgHover;
            break;
    }
    return img->GetSubImage(m_btnrect[iBtnIndex]);
}

wxRect Skin::GetButtonRect(int iBtnIndex)
{
    if ((!m_bIsOk)||(iBtnIndex>4)) return wxRect(0,0,0,0);
    return m_btnrect[iBtnIndex];
}

wxPoint Skin::GetScreenPos()
{
    if (!m_bIsOk)
        return wxPoint(0,0);
    else
        return m_brwsrpos;
}

wxBitmap Skin::GetMaskBitmap()
{
    if (!m_bIsOk)
        return wxBitmap(10,10);
    else
        return wxBitmap(m_imgMask);
}

wxBitmap Skin::GetMainBitmap()
{
    if (!m_bIsOk)
        return wxBitmap(10,10);
    else
        return wxBitmap(m_imgUp);
}

wxSize Skin::GetSize()
{
    return m_bmpsize;
}

int Skin::GetSkinVersion()
{
    return m_iVersion;
}
