#include "DataLoader.h"
#include "Settings.h"
extern Settings MyOptions;

const wxString sBaseUrl="http://www.meteofrance.com/";
const wxString sMainUrl="http://www.meteofrance.com/FR/mameteo/prevVille.jsp?LIEUID=FR";

#include <wx/wfstream.h>
#include <wx/textfile.h>
#include <wx/fs_mem.h>
#include <wx/buffer.h>
#include <wx/url.h>

DataLoader::DataLoader()
{
    //ctor
}

DataLoader::~DataLoader()
{
    //dtor
}

int DataLoader::GetMainPage(wxProgressDialog* prgdlg)
{
    wxString sUrl;
    #define iBuffLen 512
    char szBuff[iBuffLen+1];
    int iRead;
    int i;
    sUrl.Printf("%s%05d",sMainUrl.c_str(),MyOptions.iTownCode);
    wxURL theUrl(sUrl);
    wxInputStream *input=theUrl.GetInputStream();
    if (input==NULL)
    {
        wxMessageBox("Connection impossible.","Erreur",wxICON_ERROR);
        return 0;
    }
    bool bFlg=true;
    sPage.Clear();
    while(bFlg)
    {
        if (prgdlg!=NULL) prgdlg->Pulse();
        wxYield();
        input->Read(szBuff,iBuffLen);
        iRead=input->LastRead();
        if (iRead==0)
        {
            bFlg=false;
        } else {
            for (i=0;i<iRead;i++){if (szBuff[i]==10) szBuff[i]=32;}
            szBuff[iRead]=0;
            sPage.Append(szBuff);
        }
    }
    delete input;
    return 1;
}

int DataLoader::ParsePage()
{
    size_t Count=1;
    int i,j;
    // On enlve la partie finale
    i=sPage.Find("PLUS DE PR&Eacute;VISIONS");
    sPage.Remove(i);
    sPage.Shrink();
    // On enlve tous les espaces superflus
    while(Count)
    {
        Count=sPage.Replace("  "," ");
    }
    // On remplace certaines balises, pour simplifier le texte
    sPage.Replace("&eacute;","");
    sPage.Replace("&agrave;","");
    sPage.Replace("&#39;","'");
    sPage.Replace("&deg;","");
    sPage.Replace("&nbsp;"," ");
    sPage.Replace("<strong>","");
    sPage.Replace("</strong>","");
    sPage.Replace("<b>","");
    sPage.Replace("</b>","");
    sPage.Replace("<td>","");
    sPage.Replace("</td>","");
    sPage.Replace("<tr>","");
    sPage.Replace("</tr>","");
    sPage.Replace("<br>","");

    // On Recherche les infos qui nous intressent
    char *szPos,*szTmp,*szFin;
    szPos=(char*)sPage.c_str();
    // Nom de la ville
    szPos=strstr(szPos,"<title>Meteo France - Prvisions ville:")+39;
    sTown.Clear();
    while(*szPos!='<'){sTown.Append(*szPos); szPos++;}
    // Station de rfrence
    szPos=strstr(szPos,"Station de rfrence :")+22;
    szPos=strchr(szPos,'>')+1;
    sStation="";
    while(*szPos!='('){sStation.Append(*szPos); szPos++;}
    // Date et heure de mise  jour
    szPos=strstr(szPos,"Mis  jour le")+14;
    sUpdate="";
    while(*szPos!='<'){sUpdate.Append(*szPos); szPos++;}
    // Date des prvisions
    szPos=strstr(szPos,"Prvision pour le")+18;
    szPos=strchr(szPos,'>')+1;
    sDate="";
    while(*szPos!='<'){sDate.Append(*szPos); szPos++;}
    // Soleil
    szPos=strstr(szPos,"Soleil :")+8;
    szPos=strchr(szPos,'>')+1;
    sSun="";
    while(*szPos!='('){sSun.Append(*szPos); szPos++;}
    // Tempratures
    szPos=strstr(szPos,"Tempratures :")+14;
    szPos=strchr(szPos,'>')+1;
    sHealths="";
    while(*szPos!='<'){sHealths.Append(*szPos); szPos++;}
    // Image principale
    szPos=strstr(szPos,"img src=")+9;
    sMainImg=sBaseUrl;
    while(*szPos!='\"'){sMainImg.Append(*szPos); szPos++;}
    // Tableau : Heures locales
    szPos=strstr(szPos,"Heure locale :")+14;
    for (j=0;j<4;j++)
    {
        szPos=strchr(szPos,'>')+1;
        sLocTime[j]="";
        while(*szPos!='<'){sLocTime[j].Append(*szPos); szPos++;}
    }
    // Tableau : Temps sensible : Addresses des images
    szPos=strstr(szPos,"Temps sensible")+13;
    for (j=0;j<4;j++)
    {
        sImg[j]=sBaseUrl;
        szPos=strstr(szPos,"img src=")+9;
        while(*szPos!='\"'){sImg[j].Append(*szPos); szPos++;}
    }
    // Tableau : Tempratures
    szPos=strstr(szPos,"Temprature (C)")+16;
    for (j=0;j<4;j++)
    {
        szPos=strchr(szPos,'>')+1;
        sHealth[j]="";
        while(*szPos!='<'){sHealth[j].Append(*szPos); szPos++;}
    }
    // Tableau : Directions du vent
    szPos=strstr(szPos,"Direction du vent")+17;
    for (j=0;j<4;j++)
    {
        sDirect[j]="";
        szPos=strstr(szPos,"<BR>")+4;
        while(*szPos!='<'){sDirect[j].Append(*szPos); szPos++;}
    }
    // Tableau : Vitesses du vent
    szPos=strstr(szPos,"Vitesse du vent (km/h)")+22;
    for (j=0;j<4;j++)
    {
        szPos=strchr(szPos,'>')+1;
        sSpeed[j]="";
        while(*szPos<'<'){sSpeed[j].Append(*szPos); szPos++;}
    }
    i=szPos-sPage.c_str();
    sPage.Remove(0,i);
    sPage.Shrink();
    return 1;
}

int DataLoader::CreatePage()
{
    wxTextFile tfin,tfout;
    wxString sLine,sFile="",sFIn,sFOut;
    sFIn=MyOptions.sAppPath;
    sFIn.Append(".\\modele.txt");
    tfin.Open(sFIn);
    for (sLine=tfin.GetFirstLine();!tfin.Eof();sLine=tfin.GetNextLine())
    {
        sFile.Append(sLine);
        sFile.Append("\n");
    }
    tfin.Close();
    sFile.Replace("$VILLE",sTown,false);
    sFile.Replace("$STATION",sStation,false);
    sFile.Replace("$UPDATE",sUpdate,false);
    sFile.Replace("$DATE",sDate,false);
    sFile.Replace("$SOLEIL",sSun,false);
    sFile.Replace("$TEMP",sHealths,false);
    //sFile.Replace("$IMG0",sMainImg,false);
    for (int i=0;i<4;i++)
    {
        sLine.Printf("$TIME%d",i+1);
        sFile.Replace(sLine,sLocTime[i],false);
        //sLine.Printf("$IMG%d",i+1);
        //sFile.Replace(sLine,sImg[i],false);
        sLine.Printf("$TEMP%d",i+1);
        sFile.Replace(sLine,sHealth[i],false);
        sLine.Printf("$DIR%d",i+1);
        sFile.Replace(sLine,sDirect[i],false);
        sLine.Printf("$SP%d",i+1);
        sFile.Replace(sLine,sSpeed[i],false);
    }

    wxFileSystem myfs;
    wxFSFile *thefile=myfs.OpenFile("memory:Page.htm");
    if (thefile!=NULL)
    {
        delete thefile;
        wxMemoryFSHandler::RemoveFile("Page.htm");
    }
    wxMemoryFSHandler::AddFile("Page.htm",sFile);
    return 1;
}

void DataLoader::DownloadFile(const char* FileName,wxString &FileUrl)
{
    wxString sUrl;
    wxMemoryBuffer membuff(1025);
    char szBuff[1025];
    long lSize=0;
    int i,iRead;
    wxURL theUrl(FileUrl);
    wxInputStream *input=theUrl.GetInputStream();
    if (input==NULL)
    {
        wxMessageBox("Connection impossible.","Erreur",wxICON_ERROR);
        return;
    }

    bool bFlg=true;
    while(bFlg)
    {
        wxYield();
        input->Read(szBuff,1024);
        iRead=input->LastRead();
        if (iRead==0)
        {
            bFlg=false;
        } else {
            membuff.AppendData(szBuff,iRead);
            lSize+=iRead;
        }
    }
    delete input;
    wxFileSystem myfs;
    wxString sFName="memory:";
    sFName.Append(FileName);
    wxFSFile *thefile=myfs.OpenFile(sFName);
    if (thefile!=NULL)
    {
        delete thefile;
        wxMemoryFSHandler::RemoveFile(FileName);
    }
    wxMemoryFSHandler::AddFile(FileName,membuff.GetData(),membuff.GetDataLen());
}

void DataLoader::GetImages()
{
    DownloadFile("img0.gif",sMainImg);
    wxString sFName;
    for (int i=0;i<4;i++)
    {
        sFName.Printf("img%0d.gif",i+1);
        DownloadFile(sFName.c_str(),sImg[i]);
    }
}
