#include "MainFrame.h"
#include "OptionsDialog.h"
#include "Settings.h"
extern Settings MyOptions;
#include "DataLoader.h"
DataLoader MyLoader;
#include "MyApp.h"
#include "AboutDialog.h"
#include "../CommonSrc/Skin.h"
#include <wx/fs_mem.h>
#include <wx/progdlg.h>
#include "prgb.h"

bool bBkgrndInMemFS=false;

/* TODO (Maestro#1#): Gestion de l'tat minimis (system tray) */


// Stockage des ID des contrles
int iBtnID[BUTTONS_COUNT]={wxNewId(),wxNewId(),wxNewId(),wxNewId(),wxNewId()};
// Table des vnements
BEGIN_EVENT_TABLE(MainFrame,wxFrame)
    EVT_PAINT(MainFrame::OnPaint)
    //EVT_LEFT_DCLICK(MainFrame::OnDblClk)
    EVT_LEFT_DOWN(MainFrame::OnLeftBtnDown)
    EVT_LEFT_UP(MainFrame::OnLeftBtnUp)
    EVT_MOTION(MainFrame::OnMouseMove)
    EVT_BUTTON(iBtnID[BTN_CLOSE],MainFrame::OnCloseBtnPressed)
    EVT_BUTTON(iBtnID[BTN_MINIMIZE],MainFrame::OnMinimizeBtnPressed)
    EVT_BUTTON(iBtnID[BTN_OPTIONS],MainFrame::OnOptBtnPressed)
    EVT_BUTTON(iBtnID[BTN_UPDATE],MainFrame::OnReadBtnPressed)
    EVT_BUTTON(iBtnID[BTN_ABOUT],MainFrame::OnAboutBtnPressed)
END_EVENT_TABLE()

MainFrame::MainFrame()
{
    wxPoint wpos=MyOptions.WindPos;
    if (MyOptions.WindPos.x==-5000) wpos=wxDefaultPosition;

    this->Create(NULL,-1,"wxWidgets",wpos,wxSize(400,300),wxFRAME_SHAPED|wxCLIP_CHILDREN);
    CurSkin=new Skin();
    wxString sSkName=MyOptions.sAppPath;
    sSkName.Append("\\Skins\\");
    sSkName.Append(MyOptions.sSkinName);
    sSkName.Append(".zsk");
    if (!wxFileExists(sSkName)) sSkName=".\\Skins\\Default.zsk";
    if (!CurSkin->Read(sSkName))
    {
        wxMessageBox("Impossible de lire le fichier skin.","Erreur",wxICON_ERROR);
    }

    wxBitmap MaskBmp(CurSkin->GetMaskBitmap());
    bkgrnd=new wxBitmap(CurSkin->GetMainBitmap());
    wxSize SkinSize=CurSkin->GetSize();
    SetClientSize(SkinSize);
    wxRegion *rgn;
    rgn=new wxRegion(MaskBmp,*wxWHITE,0);
    SetShape(*rgn);
    delete rgn;

    wxRect rcBtn;
    wxBitmap bmpBtnUp,bmpBtnDw,bmpBtnHv;
    for (int i=BTN_CLOSE;i<BUTTONS_COUNT;i++)
    {
        bmpBtnUp=wxBitmap(CurSkin->GetButtonImage(i,BTN_STATE_NORMAL));
        bmpBtnDw=wxBitmap(CurSkin->GetButtonImage(i,BTN_STATE_PRESSED));
        rcBtn=CurSkin->GetButtonRect(i);
        BmpBtn[i]=new wxBitmapButton(this,iBtnID[i],bmpBtnUp,rcBtn.GetPosition(),rcBtn.GetSize(),0);
        BmpBtn[i]->SetBitmapSelected(bmpBtnDw);
        if (CurSkin->GetSkinVersion()>0)
        {
            bmpBtnHv=wxBitmap(CurSkin->GetButtonImage(i,BTN_STATE_HOVER));
            BmpBtn[i]->SetBitmapHover(bmpBtnHv);
        }
    }
    wxPoint htmlPos=CurSkin->GetScreenPos();
    if (bBkgrndInMemFS) wxMemoryFSHandler::RemoveFile("HtmlBkgrnd.bmp");
    wxBitmap bmphtml(bkgrnd->GetSubBitmap(wxRect(htmlPos,wxSize(400,280))));
    wxMemoryFSHandler::AddFile("HtmlBkgrnd.bmp",bmphtml,wxBITMAP_TYPE_BMP);
    bBkgrndInMemFS=true;
    // Mise en mmoire du fichier GIF
    wxMemoryFSHandler::AddFile("prgbar.gif",prgb,prgb_size);

    brwsr=new wxHtmlWindow(this,-1,htmlPos,wxSize(400,280),wxHW_DEFAULT_STYLE|wxHW_NO_SELECTION|wxHW_SCROLLBAR_NEVER);
    brwsr->SetBorders(0);
    brwsr->SetForegroundColour(*wxWHITE);
    //brwsr->SetPage("<html><body background=\"memory:HtmlBkgrnd.bmp\"><center><br><br><br><img src=\"memory:prgbar.gif\"></body></html>");
    brwsr->SetPage("<html><body background=\"memory:HtmlBkgrnd.bmp\"></body></html>");
}


MainFrame::~MainFrame()
{
    delete bkgrnd;
    delete CurSkin;
}

void MainFrame::OnPaint(wxPaintEvent &event)
{
    wxPaintDC pdc(this);
    pdc.BeginDrawing();
    wxWindowDC dc(this);
    dc.BeginDrawing();
    dc.DrawBitmap(*bkgrnd,1,1,false);
    dc.EndDrawing();
    //pdc.SetTextForeground(wxColour("YELLOW"));
    //pdc.SetFont(wxFont(14,wxSWISS,wxNORMAL,wxBOLD,FALSE));
    //pdc.DrawText("Prvisions mto pour : Cran-Gevrier",25,80);
    //pdc.DrawText("Station de rfrence : Meythet(458m)Annecy",25,105);
    //pdc.DrawText("Soleil :  Lever 06h46 - Coucher 18h41",25,130);
    pdc.EndDrawing();
    brwsr->Refresh();
}
/*
void MainFrame::OnDblClk(wxMouseEvent &event)
{
    CurSkin->SaveImages();
}
*/
void MainFrame::OnMouseMove(wxMouseEvent &event)
{
    if (event.m_leftDown==false) return;
    wxPoint NewPos=event.GetPosition();
    wxPoint NewWndPos=this->GetPosition();
    NewWndPos.x+=(NewPos.x-MousePos.x);
    NewWndPos.y+=(NewPos.y-MousePos.y);
    this->Move(NewWndPos);
    MyOptions.WindPos=NewWndPos;
}

void MainFrame::OnLeftBtnDown(wxMouseEvent &event)
{
    MousePos=event.GetPosition();
    this->CaptureMouse();
}

void MainFrame::OnLeftBtnUp(wxMouseEvent &event)
{
    this->ReleaseMouse();
}

void MainFrame::OnCloseBtnPressed(wxCommandEvent &event)
{
    Close();
}

void MainFrame::OnOptBtnPressed(wxCommandEvent &event)
{
    OptionsDialog *dlg=new OptionsDialog(this);
    dlg->SetDepartement(MyOptions.iTownCode/1000);
    dlg->SetVille(MyOptions.iTownCode);
    wxString sOldSkin=MyOptions.sSkinName;
    dlg->SetSkin(sOldSkin);
    dlg->ShowModal();
    if (sOldSkin!=MyOptions.sSkinName)
    {
        wxMessageBox("Le changement de skin sera effectif au prochain lancement du logiciel.","Changement de skin",wxICON_INFORMATION);
    }
    delete dlg;
}

void MainFrame::OnReadBtnPressed(wxCommandEvent &event)
{
    wxDialUpManager *dup=wxGetApp().GetDialer();
    if (!(dup->IsOnline()))
    {
        wxMessageBox("wxMeteo n'a dtect aucune connection active  internet.\nVous devez d'abord tablir cette connection avant de pouvoir actualiser les donnes.","Pas de connection...",wxICON_EXCLAMATION);
        return;
    }
    brwsr->SetPage("<html><body background=\"memory:HtmlBkgrnd.bmp\"><font color=\"#FFFFFF\" size=\"5\"><center><b>&nbsp;<br>&nbsp;<br>Chargement en cours,<br>patientez...<br>&nbsp;<br><img src=\"memory:prgbar.gif\"></b></center></font></body></html>");
    if (MyLoader.GetMainPage()==0)
    {
        wxMessageBox("Erreur lors du chargement de la page.","Erreur",wxICON_EXCLAMATION);
        brwsr->SetPage("<html><body background=\"memory:HtmlBkgrnd.bmp\"><font color=\"#FFFFFF\" size=\"3\"><center><b>&nbsp;<br>&nbsp;<br>Erreur lors de la lecture des donnes</b></center></font></body></html>");
        return;
    }
    MyLoader.ParsePage();
    MyLoader.GetImages();
    MyLoader.CreatePage();
    brwsr->LoadPage("memory:Page.htm");
}

void MainFrame::OnAboutBtnPressed(wxCommandEvent &event)
{
    AboutDialog *MyDlg=new AboutDialog(this);
    MyDlg->ShowModal();
    delete MyDlg;
}

void MainFrame::OnMinimizeBtnPressed(wxCommandEvent &event)
{
    Iconize(true);
}
