#include "OptionsDialog.h"
#include <wx/dir.h>
#include <wx/textfile.h>
/* TODO (Maestro#1#): Options  ajouter
  - Frquence de rafrachissement automatique
  - Etablissement de la connection sinon disponible
  - Lancement automatique au dmarrage de Windows */

#include "Settings.h"
extern Settings MyOptions;
// Stockage des ID des contrles
int iCmbDprt=wxNewId();
int iCmbTown=wxNewId();
int iCmbSkin=wxNewId();
// Table des vnements
BEGIN_EVENT_TABLE(OptionsDialog,wxDialog)
    EVT_COMBOBOX(iCmbDprt,OptionsDialog::OnDprtChanged)
    EVT_COMBOBOX(iCmbTown,OptionsDialog::OnTownChanged)
    EVT_COMBOBOX(iCmbSkin,OptionsDialog::OnSkinChanged)
    EVT_BUTTON(wxOK,OptionsDialog::OnOkPressed)
    EVT_BUTTON(wxCANCEL,OptionsDialog::OnCancelPressed)
END_EVENT_TABLE()

OptionsDialog::OptionsDialog(wxWindow *Parent) : wxDialog(Parent,-1,"wxMto::Rglages",wxDefaultPosition,wxDefaultSize,wxCAPTION)
{
    SetClientSize(300,170);
    fraMain=new wxStaticBox(this,-1,"Emplacement : ",wxPoint(5,5),wxSize(290,70));
    lblDprt=new wxStaticText(this,-1,"Dpartement :",wxPoint(10,25),wxSize(75,15),wxALIGN_RIGHT|wxST_NO_AUTORESIZE);
    cmbDprt=new wxComboBox(this,iCmbDprt,"",wxPoint(90,22),wxSize(200,100),0,NULL,wxCB_READONLY|wxCB_DROPDOWN|wxCB_SORT);
    lblTown=new wxStaticText(this,-1,"Ville :",wxPoint(10,50),wxSize(75,15),wxALIGN_RIGHT|wxST_NO_AUTORESIZE);
    cmbTown=new wxComboBox(this,iCmbTown,"",wxPoint(90,47),wxSize(200,100),0,NULL,wxCB_READONLY|wxCB_DROPDOWN);

    fraSkin=new wxStaticBox(this,-1,"Habillage : ",wxPoint(5,80),wxSize(290,45));
    lblSkin=new wxStaticText(this,-1,"Skin  utiliser :",wxPoint(10,100),wxSize(75,15),wxALIGN_RIGHT|wxST_NO_AUTORESIZE);
    cmbSkin=new wxComboBox(this,iCmbSkin,"",wxPoint(90,97),wxSize(200,100),0,NULL,wxCB_READONLY|wxCB_DROPDOWN|wxCB_SORT);

    btnOk=new wxButton(this,wxOK,"Valider",wxPoint(140,135),wxSize(75,25));
    btnOk->Enable(FALSE);
    btnCancel=new wxButton(this,wxCANCEL,"Annuler",wxPoint(220,135),wxSize(75,25));

    CentreOnParent();

    // Initialisation des variables
    iCurDprt=0;
    iCurVille=0;
    // Initialisation de la 1re ComboBox avec la liste des dpartements disponibles
    wxString sFName,sDirName=MyOptions.sAppPath;
    sDirName.Append("Datas\\");
    wxDir dir(sDirName);
    bool bRes=dir.GetFirst(&sFName,"*.cod",wxDIR_FILES);
    cmbDprt->Clear();
    while(bRes)
    {
        cmbDprt->Append(sFName.Left(sFName.Len()-4));
        bRes=dir.GetNext(&sFName);
    }
    // Initialisation de le ComboBox des Skins
    sDirName=MyOptions.sAppPath;
    sDirName.Append("Skins\\");
    dir.Open(sDirName);
    bRes=dir.GetFirst(&sFName,"*.zsk",wxDIR_FILES);
    cmbSkin->Clear();
    while(bRes)
    {
        cmbSkin->Append(sFName.Left(sFName.Len()-4));
        bRes=dir.GetNext(&sFName);
    }
}

OptionsDialog::~OptionsDialog()
{
    //dtor
}

bool OptionsDialog::SetDepartement(int DprtNum)
{
    wxString sFName,sDirName=MyOptions.sAppPath;
    sDirName.Append("Datas\\");
    wxDir dir(sDirName);
    bool bRes=dir.GetFirst(&sFName,wxString::Format("%02i*.cod",DprtNum),wxDIR_FILES);
    if (!bRes) return false;
    int iItem=cmbDprt->FindString(sFName.Left(sFName.Len()-4));
    if (iItem==wxNOT_FOUND) return false;
    cmbDprt->SetSelection(iItem);
    iCurDprt=DprtNum;
    UpdateTownComboBox();
    return false;
}

void OptionsDialog::UpdateTownComboBox()
{
    if (iCurDprt==0) return;
    wxString sFName=MyOptions.sAppPath;
    sFName.Append("Datas\\");
    sFName.Append(cmbDprt->GetStringSelection());
    sFName.Append(".cod");
    if (!wxFileExists(sFName)) return;
    cmbTown->Clear();
    wxTextFile tfile(sFName);
    wxString sLine,sCode;
    long lVal;
    tfile.Open();
    for (sLine=tfile.GetFirstLine();!tfile.Eof();sLine=tfile.GetNextLine())
    {
        sCode=sLine.Left(5);
        sCode.ToLong(&lVal);
        cmbTown->Append(sLine.Right(sLine.Len()-6),(void*)lVal);
    }
    tfile.Close();
    btnOk->Enable(FALSE);
}

bool OptionsDialog::SetVille(int iVille)
{
    int i,iTown=-1,iDprt=iVille/1000;
    if (iDprt!=iCurDprt) return false;
    for (i=0;i<cmbTown->GetCount();i++)
    {
        if ((int)(cmbTown->GetClientData(i))==iVille)
        {
            iTown=i;
            break;
        }
    }
    if (iTown==-1) return false;
    cmbTown->SetSelection(iTown);
    btnOk->Enable(TRUE);
    iCurVille=iVille;
    return true;
}

void OptionsDialog::OnDprtChanged(wxCommandEvent &event)
{
    wxString sVal=cmbDprt->GetValue();
    sVal.Truncate(2);
    long lVal=0;
    sVal.ToLong(&lVal);
    iCurDprt=(int)lVal;
    UpdateTownComboBox();
}

void OptionsDialog::OnTownChanged(wxCommandEvent &event)
{
    int iItem=cmbTown->GetSelection();
    if (iItem==wxNOT_FOUND) return;
    long lVal=(long)(cmbTown->GetClientData(iItem));
    iCurVille=(int)lVal;
    btnOk->Enable();
}

void OptionsDialog::OnOkPressed(wxCommandEvent &event)
{
    MyOptions.iTownCode=iCurVille;
    MyOptions.sTownName=cmbTown->GetValue();
    MyOptions.sSkinName=sCurSkin;
    EndModal(wxOK);
}

void OptionsDialog::OnCancelPressed(wxCommandEvent &event)
{
    EndModal(wxCANCEL);
}

void OptionsDialog::OnSkinChanged(wxCommandEvent &event)
{
    sCurSkin=cmbSkin->GetStringSelection();
}

bool OptionsDialog::SetSkin(wxString SkinName)
{
    int iItem=cmbSkin->FindString(SkinName);
    if (iItem==wxNOT_FOUND) return false;
    cmbSkin->SetSelection(iItem);
    sCurSkin=SkinName;
    return true;
}

wxString OptionsDialog::GetSkin()
{
    return sCurSkin;
}
