#include "Settings.h"
#include <wx/TextFile.h>

Settings::Settings()
{
    iTownCode=74093;
    sTownName="";
    sSkinName="Default";
    WindPos=wxPoint(-5000,-5000);
}

Settings::~Settings()
{
    //dtor
}

void Settings::ReadSettings()
{
    wxString sIniFName=sAppPath;
    sIniFName.Append("wxMeteo.ini");
    if (!wxFileExists(sIniFName)) return;
    wxTextFile fin(sIniFName);
    fin.Open();
	if (fin.Eof())
    {
        fin.Close();
        return;
    }
    wxString sLine,sKey;
    int i;
    long l;
    for (sLine=fin.GetFirstLine();!fin.Eof();sLine=fin.GetNextLine())
    {
        sLine.Trim(false);
        i=sLine.Find('=');
        if ((!sLine.IsEmpty())&&(i!=-1))
        {
            sKey=sLine.Left(i);
            sLine.Remove(0,i+1);
            if (sKey=="TownCode")
            {
                sLine.ToLong(&l);
                if (l>0) iTownCode=(int)l;
            }
            if (sKey=="TownName")
            {
                sTownName=sLine;
            }
            if (sKey=="WindPosX")
            {
                sLine.ToLong(&l);
                WindPos.x=(int)l;
            }
            if (sKey=="WindPosY")
            {
                sLine.ToLong(&l);
                WindPos.y=(int)l;
            }
            if (sKey=="SkinName")
            {
                sSkinName=sLine;
            }
        }
    }
    fin.Close();
    //sLine.Printf("TownCode=%05d\nTownName=%s",iTownCode,sTownName.c_str());
    //wxMessageBox(sLine,"Settings loaded");
}

void Settings::SaveSettings()
{
    wxString sIniFName=sAppPath;
    sIniFName.Append("wxMeteo.ini");
    if (wxFileExists(sIniFName)) wxRemoveFile(sIniFName);
    wxTextFile fout;
    fout.Create(sIniFName);
    fout.AddLine("// wxMeteo settings file");
    fout.AddLine("// Please, do not manually edit this file");
    wxString sLine;
    sLine.Printf("TownCode=%05d",iTownCode);
    fout.AddLine(sLine);
    sLine.Printf("TownName=%s",sTownName.c_str());
    fout.AddLine(sLine);
    sLine.Printf("WindPosX=%0d",WindPos.x);
    fout.AddLine(sLine);
    sLine.Printf("WindPosY=%0d",WindPos.y);
    fout.AddLine(sLine);
    sLine.Printf("SkinName=%s",sSkinName.c_str());
    fout.AddLine(sLine);

    fout.AddLine("// End of configuration file");
    fout.Write();
    fout.Close();
}
